View Issue Details

IDProjectCategoryView StatusLast Update
0000462bareos-core[All Projects] file daemonpublic2015-06-01 16:18
ReporteralexteslaAssigned To 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Platformx64OSWindows Server 2008 R2 SP1OS Version
Product Version 
Fixed in Version 
Summary0000462: windows file daemon and zero-length files in Inc backup
DescriptionIn case of Incremental backup windows FD always backups zero-length files if accurate option set to check md5 (Accurate = 5) (linux FD does not).

Director: Version: 15.1.0 (27 March 2015) x86_64-pc-linux-gnu gentoo
File Daemon: Version: 15.1.0 (27 March 2015) VSS Linux Cross-compile Win64
Steps To ReproduceFull backup:
length full path FileID
10 bytes C:/testfolder/subfolder/test-with-text.txt 627231
0 C:/testfolder/subfolder/test001.txt 627232
0 C:/testfolder/subfolder/test002.txt 627233
0 C:/testfolder/subfolder/test003.000 627234
0 C:/testfolder/subfolder/ 627235
10 bytes C:/testfolder/test-with-text.txt 627236
0 C:/testfolder/test001.txt 627237
0 C:/testfolder/test002.txt 627238
0 C:/testfolder/test004.000 627239
0 C:/testfolder/ 627240

Inc backup:
length full path FileID
0 C:/testfolder/subfolder/test001.txt 627246
0 C:/testfolder/subfolder/test002.txt 627247
0 C:/testfolder/subfolder/test003.000 627248
0 C:/testfolder/test001.txt 627249
0 C:/testfolder/test002.txt 627250
0 C:/testfolder/test004.000 627251
Additional InformationAfter 1 Full and 3 Inc:
mysql> SELECT * FROM File WHERE FilenameId = (SELECT FilenameId FROM Filename WHERE Name='test003.000') ORDER BY MD5, LStat, JobId;
+--------+-----------+-------+--------+------------+----------+--------+--------------------------------------------------+------------------------+
| FileId | FileIndex | JobId | PathId | FilenameId | DeltaSeq | MarkId | LStat | MD5 |
+--------+-----------+-------+--------+------------+----------+--------+--------------------------------------------------+------------------------+
| 627234 | 4 | 57 | 7490 | 69908 | 0 | 0 | A A IH/ B A A g A A A BVPcET BVPcET BVPcET A A L | LomeCuV2rZcA95FuoMU7jg |
| 627248 | 3 | 58 | 7490 | 69908 | 0 | 0 | A A IH/ B A A g A A A BVPcET BVPcET BVPcET A A L | LomeCuV2rZcA95FuoMU7jg |
| 627255 | 3 | 59 | 7490 | 69908 | 0 | 0 | A A IH/ B A A g A A A BVPcET BVPcET BVPcET A A L | LomeCuV2rZcA95FuoMU7jg |
| 627262 | 3 | 60 | 7490 | 69908 | 0 | 0 | A A IH/ B A A g A A A BVPcET BVPcET BVPcET A A L | LomeCuV2rZcA95FuoMU7jg |
+--------+-----------+-------+--------+------------+----------+--------+--------------------------------------------------+------------------------+
4 rows in set (0.27 sec)
TagsNo tags attached.
bareos-master: impactyes
bareos-master: actionfixed
bareos-19.2: impact
bareos-19.2: action
bareos-18.2: impact
bareos-18.2: action
bareos-17.2: impact
bareos-17.2: action
bareos-16.2: impact
bareos-16.2: action
bareos-15.2: impact
bareos-15.2: action
bareos-14.2: impactyes
bareos-14.2: actionfixed
bareos-13.2: impactyes
bareos-13.2: actionnone
bareos-12.4: impactyes
bareos-12.4: actionnone

Relationships

related to 0000460 assignedpstorz SHA1 checksum sometimes wrong 
child of 0000447 closedjoergs Release bareos-14.2.5 

Activities

alextesla

alextesla

2015-04-30 01:26

reporter  

bareos-fd.trace (58,991 bytes)
alextesla

alextesla

2015-04-30 01:31

reporter   ~0001701

Last edited: 2015-04-30 06:59

View 3 revisions

As I see in trace: filed/verify.c:437-83 C:/testfolder/subfolder/test003.000 MD5 chksum diff. Cat: LomeCuV2rZcA95FuoMU7jg File: 1B2M2Y8AsgTpgAmY7PhCfg
verify.c and backup.c generates different MD5.

In case of Linux FD: accurate.c:55-0 lookup </tmp/testfolder/subfolder/test003.000> ok

joergs

joergs

2015-05-29 18:06

administrator   ~0001763

Fix committed to bareos bareos-14.2 branch with changesetid 5358.

Related Changesets

bareos: master b75dbb84

2015-05-22 09:44:07

pstorz


Committer: mvwieringen

Ported: N/A

Details Diff
Do not assume a filetype in digest_file

Unfortunately, the ff_pkt->type is not set correctly when
digest_file is called during accurate comparison.

We get the value that stored before in ff_pkt->type by the last
file/directory that was processed, not by what we actually see.

That is why we do always calculate the digest now.

Fixes 462: windows file daemon and zero-length files in Inc backup Description
Affected Issues
0000462
mod - src/filed/verify.c Diff File

bareos: bareos-14.2 139312f5

2015-05-22 09:44:07

pstorz


Committer: joergs

Ported: N/A

Details Diff
Do not assume a filetype in digest_file

Unfortunately, the ff_pkt->type is not set correctly when
digest_file is called during accurate comparison.

We get the value that stored before in ff_pkt->type by the last
file/directory that was processed, not by what we actually see.

That is why we do always calculate the digest now.

Fixes 0000462: windows file daemon and zero-length files in Inc backup Description
Affected Issues
0000462
mod - src/filed/verify.c Diff File

Issue History

Date Modified Username Field Change
2015-04-28 03:50 alextesla New Issue
2015-04-30 01:26 alextesla File Added: bareos-fd.trace
2015-04-30 01:31 alextesla Note Added: 0001701
2015-04-30 01:54 alextesla Note Edited: 0001701 View Revisions
2015-04-30 06:59 alextesla Note Edited: 0001701 View Revisions
2015-05-21 11:30 pstorz Relationship added related to 0000460
2015-05-22 09:08 pstorz Assigned To => pstorz
2015-05-22 09:08 pstorz Status new => assigned
2015-05-26 11:56 pstorz Changeset attached => bareos master b75dbb84
2015-05-26 11:56 pstorz Status assigned => resolved
2015-05-26 11:56 pstorz Resolution open => fixed
2015-05-27 12:30 joergs Relationship added child of 0000447
2015-05-27 12:31 joergs bareos-master: impact => yes
2015-05-27 12:31 joergs bareos-master: action => fixed
2015-05-27 12:31 joergs bareos-14.2: impact => yes
2015-05-27 12:31 joergs bareos-14.2: action => will care
2015-05-27 14:06 pstorz bareos-13.2: impact => yes
2015-05-27 14:06 pstorz bareos-13.2: action => none
2015-05-27 14:06 pstorz bareos-12.4: impact => yes
2015-05-27 14:06 pstorz bareos-12.4: action => none
2015-05-27 14:18 pstorz Assigned To pstorz =>
2015-05-29 18:06 joergs Changeset attached => bareos bareos-14.2 139312f5
2015-05-29 18:06 joergs Note Added: 0001763
2015-06-01 16:18 joergs bareos-14.2: action will care => fixed
2015-06-01 16:18 joergs Status resolved => closed